diff --git a/src/BRepClass/BRepClass_FaceClassifier.cxx b/src/BRepClass/BRepClass_FaceClassifier.cxx
index f95a945..faa3d49 100644
--- a/src/BRepClass/BRepClass_FaceClassifier.cxx
+++ b/src/BRepClass/BRepClass_FaceClassifier.cxx
@@ -29,7 +29,6 @@
 #include <TopoDS.hxx>
 #include <TopoDS_Face.hxx>
 
-#if 0
 Standard_Boolean Check2D(const TopoDS_Edge &theTopE,
                          const TopoDS_Face &theTopF,
                          const Standard_Real theCurvParam,
@@ -41,14 +40,7 @@ Standard_Boolean Check2D(const TopoDS_Vertex &theTopV,
                          const TopoDS_Face &theTopF,
                          const gp_Pnt2d& thePRef,
                          const Standard_Real theTol3D);
-#else
-Standard_Boolean Check2D(const TopClass_GeomEdge& theGE,
-                         const Standard_Real theCurvParam,
-                         const gp_Pnt2d& thePRef,
-                         const Standard_Real theTol3D,
-                         gp_Pnt2d& thePOnC);
 
-#endif
 //=======================================================================
 //function : BRepClass_FaceClassifier
 //purpose  : 
@@ -62,7 +54,7 @@ BRepClass_FaceClassifier::BRepClass_FaceClassifier():myFEx(TopoDS_Face())
 //purpose  : 
 //=======================================================================
 BRepClass_FaceClassifier::BRepClass_FaceClassifier(const TopoDS_Face& theF, 
-                                                   const gp_Pnt& theP, 
+                                                   const gp_Pnt& theP,
                                                    const Standard_Real theTol3D)
 : myFEx(theF)
 {
@@ -74,10 +66,9 @@ BRepClass_FaceClassifier::BRepClass_FaceClassifier(const TopoDS_Face& theF,
 //=======================================================================
 BRepClass_FaceClassifier::
             BRepClass_FaceClassifier(const TopoDS_Face& theF, 
-                                     const gp_Pnt2d& theP,
-                                     const Standard_Real theTol3D) : myFEx(theF)
+                                     const gp_Pnt2d& theP) : myFEx(theF)
 {
-  Perform(theF, theP, theTol3D);
+  Perform(theF, theP);
 }
 
 //=======================================================================
@@ -85,166 +76,52 @@ BRepClass_FaceClassifier::
 //purpose  : 
 //=======================================================================
 void  BRepClass_FaceClassifier::Perform(const TopoDS_Face& theF, 
-                                        const gp_Pnt2d& theP, 
+                                        const gp_Pnt2d& theP,
                                         const Standard_Real theTol3D)
 {
   // First, let's check of ON-status
   
-#if 0
-  // Indeed, this code is more optimal than existing.
-  // However, it cannot be implemented until the bug #29288
-  // will be fixed.
-
-  const Standard_Real aSqTol = theTol3D*theTol3D;
-  const BRepAdaptor_Surface anAS(theF, Standard_False);
-  const gp_Pnt aPt(anAS.Value(theP.X(), theP.Y()));
-  TopoDS_Vertex aVert;
-  BRep_Builder aBB;
-  aBB.MakeVertex(aVert, aPt, Precision::Confusion());
-  TopoDS_Iterator aWirExp(theF);
-  for(; aWirExp.More(); aWirExp.Next())
   {
-    // aWir is a wire
-    const TopoDS_Shape& aWir = aWirExp.Value();
-    BRepExtrema_DistShapeShape anExtr(aWir, aVert);
-    if(!anExtr.IsDone() || (anExtr.NbSolution() < 1))
+    // Case of "ON": direct check of belonging to edge
+    // taking into account the tolerance.
+
+    //ON-status is checked in 3D-space.
+
+    const BRepAdaptor_Surface anAS(theF, Standard_False);
+    const gp_Pnt aPt(anAS.Value(theP.X(), theP.Y()));
+    TopoDS_Vertex aVert;
+    BRep_Builder aBB;
+    aBB.MakeVertex(aVert, aPt, Precision::Confusion());
+    TopoDS_Iterator aWirExp(theF);
+    for (; aWirExp.More(); aWirExp.Next())
     {
-      continue;
-    }
-
-    if(anExtr.Value() > theTol3D)
-    {
-      continue;
-    }
-
-    // It is necessary for periodic and quasi-periodic (e.g. sphere)
-    // surfaces (tests bug28211_18, bug28211_32, bug28211_33 and
-    // bug28211_35 in "tests/lowalgos/classifier/").
-    // E.g. if 2D-distance between theP and the p-curve of some edge
-    // is equal to T (the surface period) then 3D-point
-    // corresponding to theP can be exactly in the edge.
-    // So, 3D-distance is less than theTol3D however,
-    // returning ON-status is wrong in this case.
-    // Therefore, check in 2D-space is executed.
-    
-    // ATTENTION!!!
-    // This check will be wrong if theTol3D covers the 2D-distance
-    // of the surface. I.e. if two 3D-points of any cylinder (for example)
-    // having 2D-coordinates (0, 0) and (PI, 0) can
-    // be considered as same with precision theTol3D.
-    // But for periodic surfaces, Check2D(...) method
-    // can return FALSE even if theTol3D is big
-    // (because this check is based on period value
-    // instead of tolerance).
-
-    for(Standard_Integer i = 1; i <= anExtr.NbSolution(); i++)
-    {
-      if(anExtr.PointOnShape1(i).SquareDistance(aPt) > aSqTol)
-        continue;
-
-      switch(anExtr.SupportTypeShape1(i))
+      // aWir is a wire
+      const TopoDS_Shape& aWir = aWirExp.Value();
+      const Standard_Real anExtTol = (theTol3D<0.0) ? BRep_Tool::MaxTolerance(aWir, TopAbs_EDGE) : theTol3D;
+
+      // Using of BRepExtrema_DistShapeShape can give wrong result in case
+      // when the nearest edge has small tolerance and is quite big
+      // from the classified point but furthest edge has big tolerance
+      // and (therefore) contains the classified point.
+      // Moreover, it requires bug #29288 to be fixed.
+
+      BRepExtrema_DistShapeShape anExtr(aWir, aVert);
+      if (!anExtr.IsDone() || (anExtr.NbSolution() < 1))
       {
-        case BRepExtrema_IsVertex:
-        {
-          const TopoDS_Shape aSh = anExtr.SupportOnShape1(i);
-          if(Check2D(TopoDS::Vertex(aSh), theF, theP, theTol3D))
-          {
-            myState = TopAbs_ON;
-            TopTools_IndexedDataMapOfShapeListOfShape aM;
-            TopExp::MapShapesAndAncestors(theF, TopAbs_VERTEX, TopAbs_EDGE, aM);
-            const TopoDS_Shape &anE = aM.FindFromKey(aSh).First();
-            myEdgeParameter = BRep_Tool::Parameter(TopoDS::Vertex(aSh), TopoDS::Edge(anE));
-            myEdge = TopClass_GeomEdge(TopoDS::Edge(anE), theF);
-            return;
-          }
-        }
-        break;
-
-        case BRepExtrema_IsOnEdge:
-        {
-          const TopoDS_Shape aSh = anExtr.SupportOnShape1(i);
-          const TopoDS_Edge &anE = TopoDS::Edge(aSh);
-
-          //Indeed, seam-edge is included to the wire aWir twice.
-          //However, BRepExtrema_DistShapeShape will return only one
-          //representation of the nearest edge (at that this representation
-          //is chosen randomly). Maybe the edge will be chosen whose p-curve
-          //is farer from the classified point. Therefore, we must
-          //check all CurveRepresentation of this edge. For that,
-          //the flag isOnClosedSurface is used.
-          Standard_Boolean isOnClosedSurface = BRep_Tool::IsClosed(anE, theF);
-
-          if(isOnClosedSurface)
-          {
-            // See face_with_rejected_seam.brep file attached to
-            // the issue #28211 (classified point has
-            // (-1.0000000000000004 0.48095952536907932) coordinates).
-            // This face contains the edge with two p-curves (on this face)
-            // but this edge is included in the face once (i.e. indeed it is
-            // not seam). It seems that the excess p-curve was not deleted
-            // after splitting of the face but it must not be taken into
-            // account when classifying.
-            // So, we need extend check here whether this edge is really met
-            // in the wire twice.
-
-            // Take edges
-            TopoDS_Iterator anItr(aWir);
-            for(; anItr.More(); anItr.Next())
-            {
-              const TopoDS_Edge &WE = TopoDS::Edge(anItr.Value());
-              if(anE.IsSame(WE))
-              {
-                isOnClosedSurface = !isOnClosedSurface;
-              }
-            }
-          }
-
-          Standard_Real aPar = 0.0;
-          anExtr.ParOnEdgeS1(i, aPar);
-          if(Check2D(anE, theF, aPar, theP, theTol3D, isOnClosedSurface))
-          {
-            myState = TopAbs_ON;
-            myEdgeParameter = aPar;
-            myEdge = TopClass_GeomEdge(TopoDS::Edge(aSh), theF);
-            return;
-          }
-        }
-        break;
-
-        default:
-          break;
+        continue;
       }
-    }
-  }
-#else
-  const Handle(Geom_Surface) aS = BRep_Tool::Surface(theF);
-  gp_Pnt aP3d = aS->Value(theP.X(), theP.Y());
-  TopoDS_Iterator aWirExp(theF);
-  for(; aWirExp.More(); aWirExp.Next())
-  {
-    // aWir is a wire
-    const TopoDS_Shape& aWir = aWirExp.Value();
-    
-    TopoDS_Iterator anEExp(aWir);
-    for(; anEExp.More(); anEExp.Next())
-    {
-      // anE is an edge
-      const TopoDS_Edge& anE = TopoDS::Edge(anEExp.Value());
 
-      Bnd_Box aBox;
-      BRepBndLib::Add(anE, aBox);
-      aBox.Enlarge(theTol3D);
-      if (aBox.IsOut(aP3d))
+      if (anExtr.Value() > anExtTol)
+      {
         continue;
+      }
 
-      Standard_Real aFPar, aLPar;
-      const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(anE, theF, aFPar, aLPar);
-      const TopClass_GeomEdge aGE(anE, aS, aC2d, aFPar, aLPar);
-
-      Standard_Real aParam = RealFirst();
-      const Standard_Real aDist = aGE.Distance3D(aP3d, 0, &aParam);
-      if((0.0 <= aDist) && (aDist <= theTol3D))
+      TopoDS_Iterator anEExp(aWir);
+      for (; anEExp.More(); anEExp.Next())
       {
+        // anE is an edge
+        const TopoDS_Edge& anE = TopoDS::Edge(anEExp.Value());
+
         // It is necessary for periodic and quasi-periodic (e.g. sphere)
         // surfaces (tests bug28211_18, bug28211_32, bug28211_33 and
         // bug28211_35 in "tests/lowalgos/classifier/").
@@ -265,18 +142,100 @@ void  BRepClass_FaceClassifier::Perform(const TopoDS_Face& theF,
         // (because this check is based on period value
         // instead of tolerance).
 
-        gp_Pnt2d aPOnC;
-        if(Check2D(aGE, aParam, theP, theTol3D, aPOnC))
+        const Standard_Real anETol = (theTol3D<0.0) ? BRep_Tool::Tolerance(anE) : theTol3D;
+        const Standard_Real aSqTol = anETol*anETol;
+        for (Standard_Integer i = 1; i <= anExtr.NbSolution(); i++)
         {
-          myState = TopAbs_ON;
-          myEdgeParameter = aParam;
-          myEdge = aGE;
-          return;
+          if (anExtr.PointOnShape1(i).SquareDistance(aPt) > aSqTol)
+            continue;
+
+          switch (anExtr.SupportTypeShape1(i))
+          {
+            case BRepExtrema_IsVertex:
+            {
+              const TopoDS_Vertex aVert = TopoDS::Vertex(anExtr.SupportOnShape1(i));
+              if (Check2D(aVert, theF, theP, 
+                            (theTol3D<0.0) ? BRep_Tool::Tolerance(aVert) : theTol3D))
+              {
+                myState = TopAbs_ON;
+                TopTools_IndexedDataMapOfShapeListOfShape aM;
+                TopExp::MapShapesAndAncestors(theF, TopAbs_VERTEX, TopAbs_EDGE, aM);
+                const TopoDS_Edge &anE = TopoDS::Edge(aM.FindFromKey(aVert).First());
+                myEdgeParameter = BRep_Tool::Parameter(aVert, anE);
+                
+                Standard_Real aFPar, aLPar;
+                const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(anE, theF, aFPar, aLPar);
+                const Handle(Geom_Surface) aS = BRep_Tool::Surface(theF);
+                const TopClass_GeomEdge aGE(anE, aS, aC2d, aFPar, aLPar);
+                myEdge = TopClass_GeomEdge(anE, aS, aC2d, aFPar, aLPar);
+                return;
+              }
+            }
+            break;
+
+            case BRepExtrema_IsOnEdge:
+            {
+              const TopoDS_Shape aSh = anExtr.SupportOnShape1(i);
+              const TopoDS_Edge &anE = TopoDS::Edge(aSh);
+
+              //Indeed, seam-edge is included to the wire aWir twice.
+              //However, BRepExtrema_DistShapeShape will return only one
+              //representation of the nearest edge (at that this representation
+              //is chosen randomly). Maybe the edge will be chosen whose p-curve
+              //is farer from the classified point. Therefore, we must
+              //check all CurveRepresentation of this edge. For that,
+              //the flag isOnClosedSurface is used.
+              Standard_Boolean isOnClosedSurface = BRep_Tool::IsClosed(anE, theF);
+
+              if (isOnClosedSurface)
+              {
+                // See face_with_rejected_seam.brep file attached to
+                // the issue #28211 (classified point has
+                // (-1.0000000000000004 0.48095952536907932) coordinates).
+                // This face contains the edge with two p-curves (on this face)
+                // but this edge is included in the face once (i.e. indeed it is
+                // not seam). It seems that the excess p-curve was not deleted
+                // after splitting of the face but it must not be taken into
+                // account when classifying.
+                // So, we need extend check here whether this edge is really met
+                // in the wire twice.
+
+                // Take edges
+                TopoDS_Iterator anItr(aWir);
+                for (; anItr.More(); anItr.Next())
+                {
+                  const TopoDS_Edge &WE = TopoDS::Edge(anItr.Value());
+                  if (anE.IsSame(WE))
+                  {
+                    isOnClosedSurface = !isOnClosedSurface;
+                  }
+                }
+              }
+
+              Standard_Real aPar = 0.0;
+              anExtr.ParOnEdgeS1(i, aPar);
+              if (Check2D(anE, theF, aPar, theP, anETol, isOnClosedSurface))
+              {
+                myState = TopAbs_ON;
+                myEdgeParameter = aPar;
+
+                Standard_Real aFPar, aLPar;
+                const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(anE, theF, aFPar, aLPar);
+                const Handle(Geom_Surface) aS = BRep_Tool::Surface(theF);
+                const TopClass_GeomEdge aGE(anE, aS, aC2d, aFPar, aLPar);
+                myEdge = TopClass_GeomEdge(anE, aS, aC2d, aFPar, aLPar);
+                return;
+              }
+            }
+            break;
+
+            default:
+              break;
+          }
         }
       }
     }
   }
-#endif
 
   // For information only.
   // BRepClass_FaceClassifier works wrong with small faces
@@ -295,7 +254,7 @@ void  BRepClass_FaceClassifier::Perform(const TopoDS_Face& theF,
 //purpose  : 
 //=======================================================================
 void  BRepClass_FaceClassifier::Perform(const TopoDS_Face& theF, 
-                                        const gp_Pnt& theP, 
+                                        const gp_Pnt& theP,
                                         const Standard_Real theTol3D)
 {
   Standard_Integer aNbExt, aIndice, i; 
@@ -332,7 +291,7 @@ void  BRepClass_FaceClassifier::Perform(const TopoDS_Face& theF,
   if(aIndice) { 
     aExtrema.Point(aIndice).Parameter(aU1, aU2);
     aPuv.SetCoord(aU1, aU2);
-    Perform(theF, aPuv, theTol3D);
+    Perform(theF, aPuv);
   }
 }
 
@@ -362,7 +321,7 @@ static Standard_Real DeltaUMax(const Adaptor3d_Surface &theAS)
 static Standard_Real DeltaVMax(const Adaptor3d_Surface &theAS,
                                const Standard_Real theTol3D)
 {
-  switch(theAS.GetType())
+  switch (theAS.GetType())
   {
     case GeomAbs_OffsetSurface:
       //See lowalgos/classifier/bug28211_39 test case.
@@ -385,7 +344,6 @@ static Standard_Real DeltaVMax(const Adaptor3d_Surface &theAS,
   return theAS.IsVPeriodic() ? 0.25*theAS.VPeriod() : -1.0;
 }
 
-#if 0
 //=======================================================================
 //function : Check2D
 //purpose  : Returns TRUE if theP and theProjPt are the same points
@@ -398,17 +356,17 @@ Standard_Boolean Check2D(const TopoDS_Face &theTopF,
 {
   const BRepAdaptor_Surface anAS(theTopF, Standard_False);
 
-  if(anAS.GetType() == GeomAbs_OtherSurface)
+  if (anAS.GetType() == GeomAbs_OtherSurface)
     return Standard_False;
 
   const Standard_Real aDU = Abs(theProjPt.X() - thePRef.X());
   const Standard_Real aDUMax = DeltaUMax(anAS);
-  if((aDUMax >= 0.0) && (aDU > aDUMax))
+  if ((aDUMax >= 0.0) && (aDU > aDUMax))
     return Standard_False;
 
   const Standard_Real aDV = Abs(theProjPt.Y() - thePRef.Y());
   const Standard_Real aDVMax = DeltaVMax(anAS, theTol3D);
-  if((aDVMax >= 0.0) && (aDV > aDVMax))
+  if ((aDVMax >= 0.0) && (aDV > aDVMax))
     return Standard_False;
 
   return Standard_True;
@@ -427,21 +385,21 @@ Standard_Boolean Check2D(const TopoDS_Edge &theTopE,
                          const Standard_Boolean theIsOnClosedSurf)
 {
   gp_Pnt2d aPOnC;
-  if(BRep_Tool::SameParameter(theTopE) && BRep_Tool::SameRange(theTopE))
+  Standard_Real aFPar, aLPar;
+  const Handle(Geom2d_Curve) aC1 = BRep_Tool::CurveOnSurface(theTopE, theTopF, aFPar, aLPar);
+  if (BRep_Tool::SameParameter(theTopE) && BRep_Tool::SameRange(theTopE))
   {
-    Standard_Real aFPar, aLPar;
-    const Handle(Geom2d_Curve) aC1 = BRep_Tool::CurveOnSurface(theTopE, theTopF, aFPar, aLPar);
     aC1->D0(theCurvParam, aPOnC);
 
     // If theTopE is a seam-edge.
-    if(theIsOnClosedSurf)
+    if (theIsOnClosedSurf)
     {
       const Handle(Geom2d_Curve) aC2 = BRep_Tool::CurveOnSurface(TopoDS::Edge(theTopE.Reversed()),
                                                                  theTopF, aFPar, aLPar);
 
       const gp_Pnt2d aPtemp(aC2->Value(theCurvParam));
 
-      if(thePRef.SquareDistance(aPtemp) < thePRef.SquareDistance(aPOnC))
+      if (thePRef.SquareDistance(aPtemp) < thePRef.SquareDistance(aPOnC))
       {
         aPOnC = aPtemp;
       }
@@ -449,9 +407,9 @@ Standard_Boolean Check2D(const TopoDS_Edge &theTopE,
   }
   else
   {
-    TopClass_GeomEdge aGE(theTopE, theTopF);
+    TopClass_GeomEdge aGE(theTopE, BRep_Tool::Surface(theTopF), aC1, aFPar, aLPar);
     const Standard_Real aDist = aGE.Distance2D(thePRef, &aPOnC);
-    if(aDist < 0.0)
+    if (aDist < 0.0)
       return Standard_False;
   }
 
@@ -471,55 +429,3 @@ Standard_Boolean Check2D(const TopoDS_Vertex &theTopV,
   const gp_Pnt2d aPt = BRep_Tool::Parameters(theTopV, theTopF);
   return Check2D(theTopF, thePRef, aPt, theTol3D);
 }
-
-#else
-//=======================================================================
-//function : Check2D
-//purpose  : Returns TRUE if theP and thePRef are the same points.
-//           E.g. if X-coord of thePRef is equal to 0 and X-coord of theP
-//            is equal to T (the period of theSurf) then, most likely,
-//            theP and thePRef will be the same point in 3D-space.
-//           However, these points must be considered as different.
-//            It is made by this function.
-//           Another example why this function is useful is described in
-//            the test script "lowalgos/classifier/bug28211_18" (please see
-//            comment there).
-//=======================================================================
-Standard_Boolean Check2D(const TopClass_GeomEdge& theGE,
-                         const Standard_Real theCurvParam,
-                         const gp_Pnt2d& thePRef,
-                         const Standard_Real theTol3D,
-                         gp_Pnt2d& thePOnC)
-{
-  if(theGE.IsSameParameter())
-  {
-    const Geom2dAdaptor_Curve &aC = theGE.Get2DCurve();
-    aC.D0(theCurvParam, thePOnC);
-  }
-  else
-  {
-    const Standard_Real aDist = theGE.Distance2D(thePRef, &thePOnC);
-    if(aDist < 0.0)
-      return Standard_False;
-  }
-
-  const Adaptor3d_Surface &anAS = theGE.GetSurface();
-
-  if(anAS.GetType() == GeomAbs_OtherSurface)
-    return Standard_False;
-
-  const Standard_Real aDU = Abs(thePOnC.X() - thePRef.X());
-  const Standard_Real aDUMax = DeltaUMax(anAS);
-  if((aDUMax >= 0.0) && (aDU > aDUMax))
-    return Standard_False;
-
-  const Standard_Real aDV = Abs(thePOnC.Y() - thePRef.Y());
-  const Standard_Real aDVMax = DeltaVMax(anAS, theTol3D);
-  if((aDVMax >= 0.0) && (aDV > aDVMax))
-    return Standard_False;
-
-  return Standard_True;
-}
-#endif
-
-
diff --git a/src/BRepClass/BRepClass_FaceClassifier.hxx b/src/BRepClass/BRepClass_FaceClassifier.hxx
index 9b65b57..023d4ea 100644
--- a/src/BRepClass/BRepClass_FaceClassifier.hxx
+++ b/src/BRepClass/BRepClass_FaceClassifier.hxx
@@ -43,23 +43,24 @@ public:
   //! the face <theF> with 3D-tolerance <theTol3D> (used only for check ON-status).
   Standard_EXPORT 
     BRepClass_FaceClassifier(const TopoDS_Face& theF,
-                             const gp_Pnt2d& theP,
-                             const Standard_Real theTol3D);
+                             const gp_Pnt2d& theP);
   
   //! Creates an algorithm to classify the point theP relatively to
-  //! the face <theF> with 3D-tolerance <theTol3D> (used only for check ON-status).
+  //! the face <theF> with 3D-tolerance <theTol3D>.
   Standard_EXPORT BRepClass_FaceClassifier(const TopoDS_Face& theF,
                                            const gp_Pnt& theP,
                                            const Standard_Real theTol3D);
 
-  //! Classify the Point theP with 3D-tolerance <theTol3D> (used only for check ON-status)
+  //! Classify the Point theP with 3D-tolerance <theTol3D> 
+  //! (used only for check ON-status)
   //! relatively to the face <theF>.
+  //! If theTol3D < 0 then internal tolerance is used.
   Standard_EXPORT void Perform(const TopoDS_Face& theF,
                                const gp_Pnt2d& theP,
-                               const Standard_Real theTol3D);
+                               const Standard_Real theTol3D=-1.0);
   
   //! Classifies the point theP relatively to
-  //! the face <theF> with 3D-tolerance <theTol3D> (used only for check ON-status).
+  //! the face <theF> with 3D-tolerance <theTol3D>.
   Standard_EXPORT void Perform(const TopoDS_Face& theF,
                                const gp_Pnt& theP,
                                const Standard_Real theTol3D);
diff --git a/src/BRepClass/BRepClass_Intersector.cxx b/src/BRepClass/BRepClass_Intersector.cxx
index 01c7a6a..111279d 100644
--- a/src/BRepClass/BRepClass_Intersector.cxx
+++ b/src/BRepClass/BRepClass_Intersector.cxx
@@ -22,6 +22,7 @@
 #include <Geom2dInt_GInter.hxx>
 #include <Geom2dLProp_CLProps2d.hxx>
 #include <TopClass_GeomEdge.hxx>
+#include <BRep_Tool.hxx>
 
 //=======================================================================
 //function : BRepClass_Intersector
@@ -57,11 +58,14 @@ void  BRepClass_Intersector::Perform(const gp_Lin2d& theLin,
   anAdC2d.D0(aParF, pdeb);
   anAdC2d.D0(aParL, pfin);
 
+  // Domain of the line
   IntRes2d_Domain DL;
-  if (thePar != RealLast()) {
+  if (thePar != RealLast())
+  {
     DL.SetValues(aPnt2D, 0., theTol2D, ElCLib::Value(thePar, theLin), thePar, theTol2D);
   }
-  else { 
+  else
+  {
     DL.SetValues(aPnt2D, 0., theTol2D, Standard_True);
   }
 
@@ -82,4 +86,63 @@ void  BRepClass_Intersector::Perform(const gp_Lin2d& theLin,
                          Precision::PConfusion(), Precision::PIntersection());
   //
   SetValues(Inter);
-}
\ No newline at end of file
+}
+
+//=======================================================================
+//function : Check2D
+//purpose  : Returns TRUE if theP and thePRef are the same points.
+//           E.g. if X-coord of thePRef is equal to 0 and X-coord of theP
+//            is equal to T (the period of theSurf) then, most likely,
+//            theP and thePRef will be the same point in 3D-space.
+//           However, these points must be considered as different.
+//            It is made by this function.
+//           Another example why this function is useful is described in
+//            the test script "bugs modalg_6 bug28211_18" (please see
+//            comment there).
+//=======================================================================
+Standard_Boolean Check2D(const TopClass_GeomEdge& theGE,
+                         const Standard_Real theCurvParam,
+                         const gp_Pnt2d& thePRef,
+                         const Standard_Real theTol3D,
+                         gp_Pnt2d& thePOnC)
+{
+  if (theGE.IsSameParameter())
+  {
+    const Geom2dAdaptor_Curve &aC = theGE.Get2DCurve();
+    aC.D0(theCurvParam, thePOnC);
+  }
+  else
+  {
+    const Standard_Real aDist = theGE.Distance2D(thePRef, &thePOnC);
+    if (aDist < 0.0)
+      return Standard_False;
+  }
+
+  const Adaptor3d_Surface &anAS = theGE.GetSurface();
+
+  if (anAS.GetType() == GeomAbs_OtherSurface)
+    return Standard_False;
+  
+  gp_Pnt aP;
+  gp_Vec aDerU, aDerV;
+  anAS.D1(thePOnC.X(), thePOnC.Y(), aP, aDerU, aDerV);
+
+  // Resolution() method is sometimes poor
+  // it returns the value less than reality
+  // (e.g. "bugs modalg_6 bug27341_206" test case).
+  const Standard_Real aDU = Abs(thePOnC.X() - thePRef.X());
+  const Standard_Real aSqDerU = aDerU.SquareMagnitude();
+  const Standard_Real aDUMax = (aSqDerU < Precision::SquarePConfusion()) ?
+                                anAS.UResolution(theTol3D) : theTol3D / Sqrt(aSqDerU);
+  if (aDU > aDUMax)
+    return Standard_False;
+
+  const Standard_Real aDV = Abs(thePOnC.Y() - thePRef.Y());
+  const Standard_Real aSqDerV = aDerV.SquareMagnitude();
+  const Standard_Real aDVMax = (aSqDerV < Precision::SquarePConfusion()) ?
+                                anAS.VResolution(theTol3D) : theTol3D / Sqrt(aSqDerV);
+  if (aDV > aDVMax)
+    return Standard_False;
+
+  return Standard_True;
+}
diff --git a/src/BRepClass3d/BRepClass3d_Intersector3d.cxx b/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
index a1da6cf..a7b4bb8 100644
--- a/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
+++ b/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
@@ -96,7 +96,7 @@ void BRepClass3d_Intersector3d::Perform(const gp_Lin& L,
         Puv.SetY(Y - vperiod * N2);
       }
 
-      classifier2d.Perform(Face, Puv, theTol3D);
+      classifier2d.Perform(Face, Puv);
       TopAbs_State currentstate = classifier2d.State();
       if(currentstate==TopAbs_IN || currentstate==TopAbs_ON) { 
         const IntCurveSurface_IntersectionPoint& HICSPoint = HICS.Point(index);
diff --git a/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx b/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
index 91246b2..db9e13f 100644
--- a/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
+++ b/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
@@ -187,7 +187,7 @@ Standard_Boolean BRepClass3d_SolidExplorer::FindAPointInTheFace
       v_ = P.Y() + ParamInit* T.Y();
 
       //Additional check
-      BRepTopAdaptor_FClass2d Classifier(face, Precision::Confusion());
+      BRepTopAdaptor_FClass2d Classifier(face);
       gp_Pnt2d aPnt2d(u_, v_);
       TopAbs_State StateOfResultingPoint = Classifier.Perform(aPnt2d);
       if (StateOfResultingPoint != TopAbs_IN)
@@ -486,7 +486,7 @@ Standard_Integer BRepClass3d_SolidExplorer::OtherSegment(const gp_Pnt& P,
       Handle(BRepAdaptor_HSurface) surf = new BRepAdaptor_HSurface();
       if(aTestInvert)
       {
-        BRepTopAdaptor_FClass2d aClass(face, Precision::Confusion());
+        BRepTopAdaptor_FClass2d aClass(face);
         if(aClass.PerformInfinitePoint() == TopAbs_IN)
         {
           aRestr = Standard_False;
@@ -565,7 +565,7 @@ Standard_Integer BRepClass3d_SolidExplorer::OtherSegment(const gp_Pnt& P,
 
             gp_Pnt2d aPuv(aU, aV);
 
-            classifier2d.Perform(face,aPuv,Precision::Confusion());
+            classifier2d.Perform(face,aPuv);
 
             TopAbs_State aState = classifier2d.State();
 
